--- xodtemplate.c.org	2008-02-14 09:11:27.257568344 +0100
+++ xodtemplate.c	2008-02-14 09:25:25.091198272 +0100
@@ -301,7 +301,7 @@
 			gettimeofday(&tv[2],NULL);
 
 		/* cleanup some additive inheritance stuff... */
-		xodtemplate_clean_additive_strings();
+		xodtemplate_clean_strings();
 
 		/* do the meat and potatoes stuff... */
 		if(result==OK)
@@ -7250,11 +7250,8 @@
 		xodtemplate_get_inherited_string(&template_host->have_contact_groups,&template_host->contact_groups,&this_host->have_contact_groups,&this_host->contact_groups);
 		xodtemplate_get_inherited_string(&template_host->have_contacts,&template_host->contacts,&this_host->have_contacts,&this_host->contacts);
 
-		if(this_host->have_check_command==FALSE && template_host->have_check_command==TRUE){
-			if(this_host->check_command==NULL && template_host->check_command!=NULL)
-				this_host->check_command=(char *)strdup(template_host->check_command);
-			this_host->have_check_command=TRUE;
-		        }
+		xodtemplate_change_string(&template_host->have_check_command,&template_host->check_command,&this_host->have_check_command,&this_host->check_command);
+			
 		if(this_host->have_check_period==FALSE && template_host->have_check_period==TRUE){
 			if(this_host->check_period==NULL && template_host->check_period!=NULL)
 				this_host->check_period=(char *)strdup(template_host->check_period);
@@ -7501,11 +7498,8 @@
 		xodtemplate_get_inherited_string(&template_service->have_contact_groups,&template_service->contact_groups,&this_service->have_contact_groups,&this_service->contact_groups);
 		xodtemplate_get_inherited_string(&template_service->have_contacts,&template_service->contacts,&this_service->have_contacts,&this_service->contacts);
 
-		if(this_service->have_check_command==FALSE && template_service->have_check_command==TRUE){
-			if(this_service->check_command==NULL && template_service->check_command!=NULL)
-				this_service->check_command=(char *)strdup(template_service->check_command);
-			this_service->have_check_command=TRUE;
-		        }
+		xodtemplate_change_string(&template_service->have_check_command,&template_service->check_command,&this_service->have_check_command,&this_service->check_command);
+
 		if(this_service->have_check_period==FALSE && template_service->have_check_period==TRUE){
 			if(this_service->check_period==NULL && template_service->check_period!=NULL)
 				this_service->check_period=(char *)strdup(template_service->check_period);
@@ -13659,7 +13653,47 @@
 #ifdef NSCORE
 
 /******************************************************************/
-/****************** ADDITIVE INHERITANCE STUFF ********************/
+/****************** Change Stuff **********************************/
+/******************************************************************/
+
+int xodtemplate_change_string(int *have_template_value, char **template_value, int *have_this_value, char **this_value){
+	char *buf=NULL;
+
+	/* template has a value we should use */
+	if(*have_template_value==TRUE){
+		/* template has a non-NULL value */
+		if(*template_value!=NULL){
+
+			/* we have no value... */
+			if(*this_value==NULL){
+
+				/* use the template value only if we need a value - otherwise stay NULL */
+				if(*have_this_value==FALSE){
+					/* NOTE: leave leading = sign if present, as it needed during object resolution and will get stripped later */
+					*this_value=(char *)strdup(*template_value);
+					}
+				}
+			else{
+				if (*template_value[0]=='='){
+					*this_value=(char *)strdup(*template_value);
+					}
+					
+				/* otherwise our value overrides/replaces the template value */
+				
+				}
+				
+			}
+
+		/* template has a NULL value.... */
+
+		*have_this_value=TRUE;
+		}
+
+	return OK;
+	}
+
+/******************************************************************/
+/************* ADDITIVE INHERITANCE AND CHANGE STUFF **************/
 /******************************************************************/
 
 /* determines the value of an inherited string */
@@ -13709,11 +13743,11 @@
 
 
 /* removes leading + sign from various directives */
-int xodtemplate_clean_additive_string(char **str){
+int xodtemplate_clean_string(char **str){
 	char *buf=NULL;
 
 	/* remove the additive symbol if present */
-	if(*str!=NULL && *str[0]=='+'){
+	if(*str!=NULL && (*str[0]=='+' || *str[0]=='=')){
 		buf=(char *)strdup(*str+1);
 		my_free(*str);
 		*str=buf;
@@ -13725,7 +13759,7 @@
 
 /* cleans strings which may contain additive inheritance directives */
 /* NOTE: this must be done after objects are resolved */
-int xodtemplate_clean_additive_strings(void){
+int xodtemplate_clean_strings(void){
 	xodtemplate_contactgroup *temp_contactgroup=NULL;
 	xodtemplate_hostgroup *temp_hostgroup=NULL;
 	xodtemplate_servicegroup *temp_servicegroup=NULL;
@@ -13739,86 +13773,88 @@
 
 	/* resolve all contactgroup objects */
 	for(temp_contactgroup=xodtemplate_contactgroup_list;temp_contactgroup!=NULL;temp_contactgroup=temp_contactgroup->next){
-		xodtemplate_clean_additive_string(&temp_contactgroup->members);
-		xodtemplate_clean_additive_string(&temp_contactgroup->contactgroup_members);
+		xodtemplate_clean_string(&temp_contactgroup->members);
+		xodtemplate_clean_string(&temp_contactgroup->contactgroup_members);
 		}
 
 	/* resolve all hostgroup objects */
 	for(temp_hostgroup=xodtemplate_hostgroup_list;temp_hostgroup!=NULL;temp_hostgroup=temp_hostgroup->next){
-		xodtemplate_clean_additive_string(&temp_hostgroup->members);
-		xodtemplate_clean_additive_string(&temp_hostgroup->hostgroup_members);
+		xodtemplate_clean_string(&temp_hostgroup->members);
+		xodtemplate_clean_string(&temp_hostgroup->hostgroup_members);
 	        }
 
 	/* resolve all servicegroup objects */
 	for(temp_servicegroup=xodtemplate_servicegroup_list;temp_servicegroup!=NULL;temp_servicegroup=temp_servicegroup->next){
-		xodtemplate_clean_additive_string(&temp_servicegroup->members);
-		xodtemplate_clean_additive_string(&temp_servicegroup->servicegroup_members);
+		xodtemplate_clean_string(&temp_servicegroup->members);
+		xodtemplate_clean_string(&temp_servicegroup->servicegroup_members);
 	        }
 
 	/* resolve all servicedependency objects */
 	for(temp_servicedependency=xodtemplate_servicedependency_list;temp_servicedependency!=NULL;temp_servicedependency=temp_servicedependency->next){
-		xodtemplate_clean_additive_string(&temp_servicedependency->servicegroup_name);
-		xodtemplate_clean_additive_string(&temp_servicedependency->hostgroup_name);
-		xodtemplate_clean_additive_string(&temp_servicedependency->host_name);
-		xodtemplate_clean_additive_string(&temp_servicedependency->service_description);
-		xodtemplate_clean_additive_string(&temp_servicedependency->dependent_servicegroup_name);
-		xodtemplate_clean_additive_string(&temp_servicedependency->dependent_hostgroup_name);
-		xodtemplate_clean_additive_string(&temp_servicedependency->dependent_host_name);
-		xodtemplate_clean_additive_string(&temp_servicedependency->dependent_service_description);
+		xodtemplate_clean_string(&temp_servicedependency->servicegroup_name);
+		xodtemplate_clean_string(&temp_servicedependency->hostgroup_name);
+		xodtemplate_clean_string(&temp_servicedependency->host_name);
+		xodtemplate_clean_string(&temp_servicedependency->service_description);
+		xodtemplate_clean_string(&temp_servicedependency->dependent_servicegroup_name);
+		xodtemplate_clean_string(&temp_servicedependency->dependent_hostgroup_name);
+		xodtemplate_clean_string(&temp_servicedependency->dependent_host_name);
+		xodtemplate_clean_string(&temp_servicedependency->dependent_service_description);
 	        }
 
 	/* resolve all serviceescalation objects */
 	for(temp_serviceescalation=xodtemplate_serviceescalation_list;temp_serviceescalation!=NULL;temp_serviceescalation=temp_serviceescalation->next){
-		xodtemplate_clean_additive_string(&temp_serviceescalation->contact_groups);
-		xodtemplate_clean_additive_string(&temp_serviceescalation->contacts);
-		xodtemplate_clean_additive_string(&temp_serviceescalation->servicegroup_name);
-		xodtemplate_clean_additive_string(&temp_serviceescalation->hostgroup_name);
-		xodtemplate_clean_additive_string(&temp_serviceescalation->host_name);
-		xodtemplate_clean_additive_string(&temp_serviceescalation->service_description);
-		xodtemplate_clean_additive_string(&temp_serviceescalation->contact_groups);
-		xodtemplate_clean_additive_string(&temp_serviceescalation->contacts);
+		xodtemplate_clean_string(&temp_serviceescalation->contact_groups);
+		xodtemplate_clean_string(&temp_serviceescalation->contacts);
+		xodtemplate_clean_string(&temp_serviceescalation->servicegroup_name);
+		xodtemplate_clean_string(&temp_serviceescalation->hostgroup_name);
+		xodtemplate_clean_string(&temp_serviceescalation->host_name);
+		xodtemplate_clean_string(&temp_serviceescalation->service_description);
+		xodtemplate_clean_string(&temp_serviceescalation->contact_groups);
+		xodtemplate_clean_string(&temp_serviceescalation->contacts);
 	        }
 
 	/* resolve all contact objects */
 	for(temp_contact=xodtemplate_contact_list;temp_contact!=NULL;temp_contact=temp_contact->next){
-		xodtemplate_clean_additive_string(&temp_contact->contact_groups);
-		xodtemplate_clean_additive_string(&temp_contact->host_notification_commands);
-		xodtemplate_clean_additive_string(&temp_contact->service_notification_commands);
+		xodtemplate_clean_string(&temp_contact->contact_groups);
+		xodtemplate_clean_string(&temp_contact->host_notification_commands);
+		xodtemplate_clean_string(&temp_contact->service_notification_commands);
 	        }
-
+	        
 	/* clean all host objects */
 	for(temp_host=xodtemplate_host_list;temp_host!=NULL;temp_host=temp_host->next){
-		xodtemplate_clean_additive_string(&temp_host->contact_groups);
-		xodtemplate_clean_additive_string(&temp_host->contacts);
-		xodtemplate_clean_additive_string(&temp_host->parents);
-		xodtemplate_clean_additive_string(&temp_host->host_groups);
+		xodtemplate_clean_string(&temp_host->contact_groups);
+		xodtemplate_clean_string(&temp_host->contacts);
+		xodtemplate_clean_string(&temp_host->parents);
+		xodtemplate_clean_string(&temp_host->host_groups);
+		xodtemplate_clean_string(&temp_host->check_command);
 	        }
 
 	/* clean all service objects */
 	for(temp_service=xodtemplate_service_list;temp_service!=NULL;temp_service=temp_service->next){
-		xodtemplate_clean_additive_string(&temp_service->contact_groups);
-		xodtemplate_clean_additive_string(&temp_service->contacts);
-		xodtemplate_clean_additive_string(&temp_service->host_name);
-		xodtemplate_clean_additive_string(&temp_service->hostgroup_name);
-		xodtemplate_clean_additive_string(&temp_service->service_groups);
+		xodtemplate_clean_string(&temp_service->contact_groups);
+		xodtemplate_clean_string(&temp_service->contacts);
+		xodtemplate_clean_string(&temp_service->host_name);
+		xodtemplate_clean_string(&temp_service->hostgroup_name);
+		xodtemplate_clean_string(&temp_service->service_groups);
+		xodtemplate_clean_string(&temp_service->check_command);
 	        }
 
 	/* resolve all hostdependency objects */
 	for(temp_hostdependency=xodtemplate_hostdependency_list;temp_hostdependency!=NULL;temp_hostdependency=temp_hostdependency->next){
-		xodtemplate_clean_additive_string(&temp_hostdependency->host_name);
-		xodtemplate_clean_additive_string(&temp_hostdependency->dependent_host_name);
-		xodtemplate_clean_additive_string(&temp_hostdependency->hostgroup_name);
-		xodtemplate_clean_additive_string(&temp_hostdependency->dependent_hostgroup_name);
+		xodtemplate_clean_string(&temp_hostdependency->host_name);
+		xodtemplate_clean_string(&temp_hostdependency->dependent_host_name);
+		xodtemplate_clean_string(&temp_hostdependency->hostgroup_name);
+		xodtemplate_clean_string(&temp_hostdependency->dependent_hostgroup_name);
 	        }
-
+	        
 	/* resolve all hostescalation objects */
 	for(temp_hostescalation=xodtemplate_hostescalation_list;temp_hostescalation!=NULL;temp_hostescalation=temp_hostescalation->next){
-		xodtemplate_clean_additive_string(&temp_hostescalation->contact_groups);
-		xodtemplate_clean_additive_string(&temp_hostescalation->contacts);
-		xodtemplate_clean_additive_string(&temp_hostescalation->host_name);
-		xodtemplate_clean_additive_string(&temp_hostescalation->hostgroup_name);
-		xodtemplate_clean_additive_string(&temp_hostescalation->contact_groups);
-		xodtemplate_clean_additive_string(&temp_hostescalation->contacts);
+		xodtemplate_clean_string(&temp_hostescalation->contact_groups);
+		xodtemplate_clean_string(&temp_hostescalation->contacts);
+		xodtemplate_clean_string(&temp_hostescalation->host_name);
+		xodtemplate_clean_string(&temp_hostescalation->hostgroup_name);
+		xodtemplate_clean_string(&temp_hostescalation->contact_groups);
+		xodtemplate_clean_string(&temp_hostescalation->contacts);
 	        }
 
 	return OK;
